package quimufu.colourful_portals.general_util;


import org.joml.Random;

import java.util.TreeMap;

public class WeightedSelector <E> {

    private final TreeMap<Integer, E> backingMap = new TreeMap<>();

    private int total = 0;

    public void add(E object, int weight){
        if(weight <= 0){
            return;
        }
        backingMap.put(total, object);
        total += weight;
    }

    public void clear() {
        total = 0;
        backingMap.clear();
    }

    public E getWeighted(Random random) {
        if(total == 0){
            throw new IllegalStateException("tried to receive Weighted Result from empty Selector");
        }
        return backingMap.floorEntry(random.nextInt(total)).getValue();
    }

}
