package quimufu.colourful_portals.util;

import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityDimensions;
import net.minecraft.particle.ParticleTypes;
import net.minecraft.util.math.Box;
import net.minecraft.world.World;
import org.joml.Random;
import org.joml.Vector3f;

public class TeleportParticleHelper {
    private static final Random random = new Random();

    public static void spawnTeleportationParticles(Entity entity, World world) {
        for (int i = 0; i < 64; ++i) {
            Box box = entity.getBoundingBox();
            float xOffset = (float) ((AdditionalMath.root(random.nextFloat() * 2 - 1, 3) / 2) * box.getLengthX() * 2);
            float yOffset = (float) (AdditionalMath.root(random.nextFloat(), 3) * box.getLengthY() * 2);
            float zOffset = (float) ((AdditionalMath.root(random.nextFloat() * 2 - 1, 3) / 2) * box.getLengthZ() * 2);

            Vector3f offset = new Vector3f(xOffset, yOffset, zOffset);
            EntityDimensions dimensions = EntityDimensions.fixed(0.25f, 0.25f);
            Vector3f endPos = randomInside(dimensions.getBoxAt(entity.getPos())).add(offset);
            world.addParticle(ParticleTypes.PORTAL,
                    endPos.x, endPos.y, endPos.z,
                    -offset.x, -offset.y, -offset.z);
        }
    }

    private static Vector3f randomInside(Box box) {
        return box.getMinPos().toVector3f()
                .add(((float) box.getLengthX()) * random.nextFloat(),
                        ((float) box.getLengthY()) * random.nextFloat(),
                        ((float) box.getLengthZ()) * random.nextFloat());
    }
}
